﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Microsoft.Win32;
using Microsoft.Office.Interop.Excel;
using Microsoft.Office.Interop.Word;


namespace BSETAudit
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }    
        

        
        
        private void GetInstalledPrograms()
        {
            RegistryKey localmachine = Registry.LocalMachine;
            RegistryKey Uninstall = localmachine.OpenSubKey(@"Software\Microsoft\Windows\CurrentVersion\Uninstall");

            foreach (string key in Uninstall.GetSubKeyNames())
            {
                RegistryKey activeKey = Uninstall.OpenSubKey(key);
                string displayName = (string)activeKey.GetValue("DisplayName");
                string Publisher = (string)activeKey.GetValue("Publisher");

                if (!String.IsNullOrEmpty(displayName))
                    listbox1.Items.Add(displayName);
             }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            GetInstalledPrograms();
        }

        private void closeBSETAuditToolStripMenuItem_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void btnExcel_Click(object sender, EventArgs e)
        {
            Microsoft.Office.Interop.Excel.Application app = new Microsoft.Office.Interop.Excel.Application();
            app.Visible = true;
            

            Microsoft.Office.Interop.Excel.Workbook wb = app.Workbooks.Add(1);
            Microsoft.Office.Interop.Excel.Worksheet ws = (Microsoft.Office.Interop.Excel.Worksheet)wb.Worksheets[1];
            int i = 1;
            int i2 = 1;
            foreach (ListViewItem lvi in listbox1.Items)
            {
                i = 1;
                foreach (ListViewItem.ListViewSubItem lvs in lvi.SubItems)
                {
                    ws.Cells[i2, i] = lvs.Text;

                    i++;
                }
                i2++;
            }
        }

        private void button3_Click(object sender, EventArgs e)
        {
            listbox1.Items.Clear();
        }

        private void button2_Click(object sender, EventArgs e)
        {
            {
                saveFileDialog1.Filter = "CSV Files (*.csv)|*.csv";
                saveFileDialog1.FileName = "ProgramAudit";
                saveFileDialog1.Title = "Export to CSV";
                StringBuilder sb = new StringBuilder();

                foreach (ColumnHeader ch in listbox1.Columns)
                {
                    sb.Append(ch.Text + ",");
                }

                sb.AppendLine();

                foreach (ListViewItem lvi in listbox1.Items)
                {
                    foreach (ListViewItem.ListViewSubItem lvs in lvi.SubItems)
                    {
                        if (lvs.Text.Trim() == string.Empty)
                            sb.Append(" ,");

                        else
                            sb.Append(lvs.Text + ",");
                    }

                    sb.AppendLine();

                }

                DialogResult dr = saveFileDialog1.ShowDialog();
                if (dr == DialogResult.OK)
                {
                    StreamWriter sw = new StreamWriter(saveFileDialog1.FileName);
                    sw.Write(sb.ToString());
                    sw.Close();
                }
            }
        }

        private void closeBSETAuditToolStripMenuItem_Click_1(object sender, EventArgs e)
        {
            this.Close();
        }



        
     }

   }


